. ${_EXEC}/templates/text_attendee.sh
. ${_EXEC}/templates/view_attendee.sh
. ${_EXEC}/templates/edit_attendee.sh

check(){
  [ "$_GET[\"filtertype\"]" = "$1" ] && echo 'checked="checked"'
}

cat <<EOF
<div class="filter">
<form action="/" method="GET">
  <div class="search">
    <span class="label">Filter:</span>
    <input type="hidden" name="page" value="attendees"/>
    <input type="text" name="filter" value="$_GET["filter"]"/><br/>
    <input type="radio" name="filtertype" value="any" $(check any)>$(l10n filter_all)</input>
    <input type="radio" name="filtertype" value="name" $(check name)>$(l10n filter_name)</input>
    <input type="radio" name="filtertype" value="street" $(check street)>$(l10n filter_street)</input>
    <input type="radio" name="filtertype" value="zip" $(check zip)>$(l10n filter_zip)</input>
    <input type="radio" name="filtertype" value="telephone" $(check telephone)>$(l10n filter_phone)</input>
    <input type="radio" name="filtertype" value="birth" $(check birth)>$(l10n filter_birthyear)</input>
    <input type="radio" name="filtertype" value="course" $(check course)>$(l10n filter_course)</input><br/>
    <button type="submit" name="action" value="new_filter">$(l10n filter_apply)</button>
    <button type="submit" name="action" value="del_filter">$(l10n filter_cancel)</button>
  </div>
</form>
</div>

<div class="newcard">
<h2>Neuer Eintrag</h2>
<form action="actions/newcard.cgi" method="POST">
  <span class="label">Name:</span>
  <input type="text" name="name"/>
  <button type="submit">Anlegen</button>
</form>
</div>

<div class="cardlist">
$(listcards |while read card; do
  id="$(basename "$card")"
  if [ "$_GET[\"edit\"]" = "$id" ]; then cat <<x_EOF
  <div id="${id}" class="card">
    <form action="/?action=update_attendee" method="POST">
      <input type="hidden" name="card" value="${id}"/>
      $(edit_attendee "$id")
      <br /><select name="newfield">
	<option value="" disabled="disabled" selected="selected">$(l10n edit_addfieldtext)</option>
	$(for f in $VCF_FIELDS; do echo "<option value=\"$f\">$(l10n $f)</option>"; done)
      </select>
      <button type="submit" name="action" value="addfield">$(l10n edit_addfield)</button>
      <br /><button type="submit" name="action" value="update">$(l10n edit_update)</button>
      <br /><button type="submit" name="action" value="cancel">$(l10n edit_cancel)</button>
    </form>
  </div>
x_EOF
  else cat <<x_EOF
  <div id="${id}" class="card">
    $(view_attendee "$id")
  </div>
x_EOF
  fi
done)
</div>

EOF

# vi:set filetype=html:
